############################################################################
# Copyright (C) 2003 Eric Seigne
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : editeur.tcl
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version    $Id: editsoustractions.tcl,v 1.2 2004/11/14 15:38:27 david Exp $
# @author     David Lucardi
# @project
# @copyright  Eric Seigne
#
#
#########################################################################
#!/bin/sh
#Editeur.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

##################################"sourcing
set plateforme $tcl_platform(platform)
set ident $tcl_platform(user)

source fonts.tcl
source path.tcl
source eval.tcl
source msg.tcl

inithome
initlog $plateforme $ident
changehome

set fichier [file join $basedir aide index.htm]
bind . <F1> "exec $progaide \042$fichier\042 &"


. configure -background blue
frame .geneframe -background blue -height 300 -width 400
pack .geneframe -side left


#################################################gnration interface
proc interface {} {
global sysFont 



catch {destroy .geneframe}

catch {destroy .leftframe}

frame .leftframe -background blue -height 400 -width 100 
pack .leftframe -side left -anchor n

frame .geneframe -background blue -height 300 -width 200
pack .geneframe -side top -anchor n
frame .geneframe2 -background blue -height 300 -width 200
pack .geneframe2 -side top -anchor n

label .leftframe.lignevert1 -bg red -text "" -font {Arial 1}
pack .leftframe.lignevert1 -side right -expand 1 -fill y

######################leftframe.frame1
frame .leftframe.frame1 -background blue -width 100 
pack .leftframe.frame1 -side top 

label .leftframe.frame1.lab1 -foreground red -bg white -text [mc {Soustractions}] -font $sysFont(l)
pack .leftframe.frame1.lab1 -side top -fill x -pady 5

label .leftframe.frame1.lab2 -bg blue -foreground white -text [mc {Scenario}] -font $sysFont(l)
pack .leftframe.frame1.lab2 -side top -fill x -expand 1 -pady 5

listbox .leftframe.frame1.listsce -yscrollcommand ".leftframe.frame1.scrollpage set" -width 15 -height 6
scrollbar .leftframe.frame1.scrollpage -command ".leftframe.frame1.listsce yview" -width 7
pack .leftframe.frame1.listsce .leftframe.frame1.scrollpage -side left -fill y -expand 1 -pady 10
bind .leftframe.frame1.listsce <ButtonRelease-1> "changelistsce %x %y"

############################leftframe.frame2
frame .leftframe.frame2 -background blue -width 100 
pack .leftframe.frame2 -side top 
button .leftframe.frame2.but0 -text [mc {Nouveau}] -command "additem" -activebackground white
pack .leftframe.frame2.but0 -pady 5 -side top
button .leftframe.frame2.but1 -text [mc {Supprimer}] -command "delitem" -activebackground white
pack .leftframe.frame2.but1 -pady 5 -side top


########################leftframe.frame3
frame .leftframe.frame3 -background blue -width 100 
pack .leftframe.frame3 -side top 
button .leftframe.frame3.but0 -text [mc {ok}] -command "fin" -activebackground white
pack .leftframe.frame3.but0 -pady 5 -side bottom

label .geneframe.lab1 -text [mc {Serie}] -font $sysFont(l) -bg blue
pack .geneframe.lab1 -side top -fill x -pady 5


listbox .geneframe.listsce -yscrollcommand ".geneframe.scrollpage set" -width 50 -height 6
scrollbar .geneframe.scrollpage -command ".geneframe.listsce yview" -width 7
pack .geneframe.listsce .geneframe.scrollpage -side left -fill y -expand 1 -pady 10
bind .geneframe.listsce <ButtonRelease-1> "changelistpage %x %y"

entry .geneframe2.entobj -font $sysFont(s) -width 50
pack .geneframe2.entobj -side top -pady 20
button .geneframe2.ajout -background gray75 -text [mc {Ajouter}] -command "addope"
pack .geneframe2.ajout -side left -padx 20
button .geneframe2.supp -background gray75 -text [mc {Supprimer}] -command "delope"
pack .geneframe2.supp -side left -padx 20



}



####################################################################"""
proc charge {index} {
global listdata activelist indexpage totalpage Home indlist

set f [open [file join $Home reglages soustractions.conf] "r"]
set listdata [gets $f]
close $f

set totalpage [llength $listdata] 
set indexpage $index
.leftframe.frame1.listsce delete 0 end
for {set k 0} {$k < [llength $listdata]} {incr k 1} {
.leftframe.frame1.listsce insert end [lindex [lindex $listdata $k] 0]
}
set activelist [lindex [lindex $listdata $indexpage] 2]
.leftframe.frame1.listsce selection set $indexpage


.geneframe.listsce delete 0 end
for {set k 0} {$k < [llength $activelist]} {incr k 1} {
.geneframe.listsce insert end [lindex $activelist $k]
}
.geneframe.listsce selection set 0
set indlist 0
.geneframe2.entobj delete 0 end
.geneframe2.entobj insert end [.geneframe.listsce get 0]
}




###################################################################################"
proc enregistre_sce {} {
global indexpage listdata activelist totalpage Home indlist

set activelist [.leftframe.frame1.listsce get $indexpage]\0400\040
set tmp ""
for {set i 0} { $i < [.geneframe.listsce index end] } {incr i 1} {
set tmp "$tmp \{[.geneframe.listsce get $i]\}"
}
set tmp \173$tmp\175
set activelist $activelist$tmp

set listdata [lreplace $listdata $indexpage $indexpage $activelist]
set f [open [file join $Home reglages soustractions.conf] "w"]
puts $f $listdata
close $f
}

###################################################################
proc changelistsce {x y} {
global ind indlist
enregistre_sce
set ind [.leftframe.frame1.listsce index @$x,$y]
set indlist 0
charge $ind
.leftframe.frame1.lab2 configure -text [.leftframe.frame1.listsce get @$x,$y]
}

proc changelistpage {x y} {
global indlist
set indlist [.geneframe.listsce index @$x,$y]
.geneframe2.entobj delete 0 end
.geneframe2.entobj insert end [.geneframe.listsce get $indlist]
}

proc fin {} {
enregistre_sce
destroy .
}

#######################################################################
proc delitem {} {
global listdata indexpage totalpage Home
	if {$totalpage < 2} {
	tk_messageBox -message [mc {Impossible de supprimer la fiche}] -type ok -title [mc {Soustractions}]
	return
	}
set response [tk_messageBox -message [format [mc {Voulez-vous vraiment supprimer la fiche %1$s ?}] [lindex [lindex $listdata $indexpage] 0]] -type yesno -title [mc {Soustractions}]]
	if {$response == "yes"} {
	set totalpage [expr $totalpage - 1]
		set listdata [lreplace $listdata $indexpage $indexpage]
     		if {$indexpage > 0} {
     		set indexpage [expr $indexpage - 1]						
		} 
	set f [open [file join $Home reglages soustractions.conf] "w"]
	puts $f $listdata
	close $f
	charge $indexpage

	} 

}


proc additem {} {
global listdata indexpage totalpage
enregistre_sce
catch {destroy .nomobj}
toplevel .nomobj -background grey -width 250 -height 100
wm geometry .nomobj +50+50
frame .nomobj.frame -background grey -width 250 -height 100
pack .nomobj.frame -side top
label .nomobj.frame.labobj -font {Helvetica 10} -text [mc {Nom du scenario :}] -background grey
pack .nomobj.frame.labobj -side top 
entry .nomobj.frame.entobj -font {Helvetica 10} -width 10
pack .nomobj.frame.entobj -side top 
button .nomobj.frame.ok -background gray75 -text [mc {Ok}] -command "verifnomobj"
pack .nomobj.frame.ok -side top -pady 10
}

proc verifnomobj {} {
global nom listdata indexpage totalpage Home
set ext .conf
set nom [join [.nomobj.frame.entobj get] ""]
if {$nom !=""} {
set indexpage $totalpage
incr totalpage
lappend listdata "$nom 0"
set f [open [file join $Home reglages soustractions.conf] "w"]
puts $f $listdata
close $f
charge $indexpage
}
catch {destroy .nomobj}
}

#proc changelistsce2 {x y} {
#.leftframe.frame3.choix configure -text [.leftframe.frame3.listsce2 get @$x,$y]
#}

proc addope {} {
global indlist
set tmp [.geneframe2.entobj get]
if {$tmp !=""} {

if {[llength $tmp] !=2} {
set answer [tk_messageBox -message [mc {2 nombres pour une soustraction!}] -type ok] 
return
}
foreach item $tmp {

if {[string is double [string map {, .} $item]] == 0} {
set answer [tk_messageBox -message [mc {Veuillez entrer des nombres valides!}] -type ok] 
return
}
}
if {[expr [string map {, .} [lindex $tmp 0]]] < [expr [string map {, .} [lindex $tmp 1]]]} {
set answer [tk_messageBox -message [mc {Le premier nombre doit etre superieur au deuxieme}] -type ok] 
return
}
.geneframe.listsce insert [expr $indlist +1] $tmp
}
}

proc delope {} {
global indlist
.geneframe.listsce delete $indlist 
set indlist 0
.geneframe.listsce selection set $indlist

.geneframe2.entobj delete 0 end
.geneframe2.entobj insert end [.geneframe.listsce get $indlist]
#set indlist [expr $indlist - 1]
}
interface
charge 0
