############################################################################
# Copyright (C) 2004 Eric Seigne
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : Soustractions.tcl
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 01/11/2004
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version    $Id: soustractions.tcl,v 1.3 2004/12/21 08:25:38 david Exp $
# @author     David Lucardi
# @project
# @copyright  Eric Seigne
#
#
#########################################################################
#!/bin/sh
#soustractions.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

global plateforme user listdata arg1 listgen indfich
set plateforme $tcl_platform(platform)
set ident $tcl_platform(user)

source fonts.tcl
source path.tcl
source eval.tcl
source msg.tcl

inithome
initlog $plateforme $ident
changehome


set c .frame.c
########################################
set arg1 [lindex $argv 0]
#set arg1 0
#########################################"

#interface
. configure -background #ffff80 
frame .frame -width 640 -height 420 -background #ffff80
pack .frame -side top -fill both -expand yes
wm geometry . +0+0
canvas $c -width 640 -height 400 -background #ffff80 -highlightbackground #ffff80
pack $c

#ouverture du fichier Soustractions.conf
set f [open [file join $Home reglages soustractions.conf] "r"]
set listgen [gets $f]
close $f

image create photo bien -file [file join sysdata pbien.gif] 
image create photo pass -file [file join sysdata ppass.gif]
image create photo mal -file [file join sysdata pmal.gif]
image create photo neutre -file [file join sysdata pneutre.gif]
image create photo ok1 -file [file join sysdata ok1.gif]
image create photo ok0 -file [file join sysdata ok0.gif]

set indfich 0


#procdure principale
proc place {c} {
global listdata arg1 listgen user basedir progaide mode data indfich total sysFont nbcol nbrow curcol currow plateforme taillerect org0 org1 donnee resultat decim partint partdec erreurscalcul erreursplacement
#recup de l'activit dans listdata
set listdata [lindex $listgen $arg1]
wm title . "[mc {Soustractions}] [lindex [lindex $listdata 0] 0]"
catch {destroy .bframe}
frame .bframe -background #ffff80
pack .bframe -side bottom

set erreurscalcul 0
set erreursplacement 0

set mode [lindex $listdata 1]
set data [lindex $listdata 2]
set donnee [lindex $data $indfich]
#set fichier [file join $basedir aide index.htm]
#bind . <F1> "exec $progaide \042$fichier\042 &"

#label .bframe.tete -background #ffff80 -image neutre
#grid .bframe.tete -column 0 -padx 10 -row 0
label .bframe.consigne -background #ffff80 -text [mc {Pose l'operation et appuie sur la touche entree}]
grid .bframe.consigne -column 0 -padx 10 -row 0
#button .bframe.ok -background #ffff80 -image ok1 -command "verifplace $c"
#grid .bframe.ok -column 1 -padx 10 -row 0
bind $c <Return> "verifplace $c"
set total [llength $data]
$c delete all

set decim 0
set tmp 0
set partint 0
set partdec 0

for {set i 0} {$i < [llength $donnee]} {incr i 1} {
set l$i [string length [lindex $donnee $i]]
if {[expr \$l$i] > $tmp} {set tmp [expr \$l$i]}
if {[string first , [lindex $donnee $i]] != -1} {set decim 1}
}


set nbcol $tmp

if {$decim == 1} {
for {set i 0} {$i < [llength $donnee]} {incr i 1} {
set tmp [lindex $donnee $i]
set virg ,
if {[string first , $tmp] == -1} {
set tmp $tmp$virg
}
if {$partint < [expr [string first , $tmp]]} {set partint [expr [string first , $tmp]]}
if {$partdec < [expr [string length $tmp] - [string first , $tmp] -1]} {set partdec [expr [string length $tmp] - [string first , $tmp]-1]}
}
set nbcol [expr $partint + $partdec +1]
}

set nbrow [expr [llength $donnee]]
set currow 0
set curcol $nbcol
set taillerect 25
set org0 [expr 320 - int((($nbcol +1)*$taillerect)/2)]
set org1 50

set tmp [lindex $donnee 0]
for {set i 1} {$i < [llength $donnee]} {incr i 1} {
set tmp "$tmp - [lindex $donnee $i]"
}
$c create text [expr 320] [expr 20] -text $tmp -font $sysFont(t) -tags operation
#set resultat [expr [string map {, .} [lindex $donnee 0]] + [string map {, .} [lindex $donnee 1]]]
set resultat [expr [string map {, .} $tmp]]


###################################################"
for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    $c create rect [expr $org0 + $i*$taillerect] [expr $org1 + $j*$taillerect ]  [expr $org0 + ($i+1)*$taillerect]  [expr $org1 + ($j+1)*$taillerect]  -width 2 -fill gray -tags rectcol[expr \$i]row[expr \$j]
    $c create text [expr $org0 + $i*$taillerect + int($taillerect/2)] [expr $org1 + $j*$taillerect + int($taillerect/2)] -tags textcol[expr \$i]row[expr \$j] -font $sysFont(t)

  }
}
for {set i 1} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow -1]} {incr j 1} {
    $c itemconf  textcol[expr \$i]row[expr \$j] -text .
    $c bind rectcol[expr \$i]row[expr \$j] <ButtonRelease-1> "changefocus $c"
    $c bind textcol[expr \$i]row[expr \$j] <ButtonRelease-1> "changefocus $c"

  }
}

for {set i 2} {$i <= [expr $nbcol]} {incr i 1} {
    $c create text [expr $org0 + $i*$taillerect + 4] [expr $org1 + int($taillerect) -5 ] -tags retcol[expr \$i]row0 -font $sysFont(s) -fill blue
}

for {set i 1} {$i < [expr $nbcol]} {incr i 1} {
    $c create text [expr $org0 + $i*$taillerect + int($taillerect/2)] [expr $org1 + 2*int($taillerect) -5 ] -tags retcol[expr \$i]row1 -font $sysFont(s) -fill blue
}

bind $c <KeyPress> "changenum $c %K"
bind $c <Right> "changecell $c right 0 [expr $nbrow -1] 1 $nbcol"
bind $c <Up> "changecell $c up 0 [expr $nbrow -1] 1 $nbcol"
bind $c <Left> "changecell $c left 0 [expr $nbrow -1] 1 $nbcol"
bind $c <Down> "changecell $c down 0 [expr $nbrow -1] 1 $nbcol"

if { $plateforme == "unix" }  {
bind $c <KP_Right> "changecell $c right 0 [expr $nbrow -1] 1 $nbcol"
bind $c <KP_Left> "changecell $c left 0 [expr $nbrow -1] 1 $nbcol"
bind $c "changecell $c down 0 [expr $nbrow -1] 1 $nbcol"
bind $c  <KP_Up> "changecell $c up 0 [expr $nbrow -1] 1 $nbcol"
}

focus -force .frame.c
for {set i 1} {$i < [expr $nbrow]} {incr i 1} {
$c itemconf textcol0row$i -text -
}
$c create line [expr $org0] [expr $org1 + $nbrow*$taillerect ]  [expr $org0 + [expr $nbcol +1]*$taillerect]  [expr $org1 + $nbrow*$taillerect]  -width 4 -fill red -tags line
$c itemconf rectcol[expr \$nbcol]row1 -fill white

}


#appel de la procdure principale
place $c


proc changeret {c} {
global nbcol nbrow taillerect org0 org1
set coord [$c coords current]
set xc [expr int(([lindex $coord 0]- $org0)/$taillerect)]
set yc [expr int(([lindex $coord 1]-$org1)/$taillerect)]
set tmp [$c itemcget retcol[expr \$xc]row[expr \$yc] -text]
if {$tmp == ""} {
$c itemconf retcol[expr \$xc]row[expr \$yc] -text 1
} else {
$c itemconf retcol[expr \$xc]row[expr \$yc] -text ""
}
}

proc changefocus {c} {
global nbcol nbrow curcol currow taillerect org0 org1
for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    $c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
  }
}
set coord [$c coords current]
set xc [expr int(([lindex $coord 0]- $org0)/$taillerect)]
set yc [expr int(([lindex $coord 1]-$org1)/$taillerect)]
$c itemconf rectcol[expr \$xc]row[expr \$yc] -fill white
set curcol $xc
set currow $yc
}

proc changecell {c where rmin rmax cmin cmax} {
global nbcol nbrow curcol currow taillerect
   switch $where {
        right { 
		  set tmp [expr $curcol +1]
		    if {$tmp <= $cmax} {
			set curcol $tmp
		    }
		  }
	left { 
		  set tmp [expr $curcol -1]
		    if {$tmp >= $cmin} {
			set curcol $tmp
		    }
		  }
	down { 
		  set tmp [expr $currow +1]
		    if {$tmp <= $rmax} {
			set currow $tmp
		    }
		  }
	up { 
		  set tmp [expr $currow -1]
		    if {$tmp >= $rmin} {
			set currow $tmp
		    }
		  }

  }
for {set i 1} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow -1]} {incr j 1} {
    $c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
  }
}
$c itemconf rectcol[expr \$curcol]row[expr \$currow] -fill white

}

proc changenum {c key} {
global curcol currow
focus -force .frame.c

switch $key {
BackSpace - Delete {$c itemconf textcol[expr \$curcol]row[expr \$currow] -text .}
0 - 1 - 2 - 3 - 4 - 5 - 6 - 7 - 8 - 9  {$c itemconf textcol[expr \$curcol]row[expr \$currow] -text $key}
comma {$c itemconf textcol[expr \$curcol]row[expr \$currow] -text ,}
}
}

proc verifplace {c} {
global nbcol donnee nbrow currow curcol sysFont activecol decim partint partdec erreursplacement
	for {set j 0} {$j < [expr $nbrow]} {incr j 1} {
	set nomb ""
	set saisie ""
		for {set i 1} {$i <= [expr $nbcol]} {incr i 1} {
		set saisie [$c itemcget textcol[expr \$i]row[expr \$j] -text]
		set nomb $nomb$saisie
		}
########################################################################
	set tmp [string trim $nomb .]
		if {[string first . $tmp] != -1} {
# pas de . au milieu du nombre
		set answer [tk_messageBox -message "[mc {Erreur au nombre}] [expr $j + 1]" -type ok] 
		incr erreursplacement
		return
		}

	if {$decim ==0} {
		if {[string equal [string trimleft [lindex $donnee [expr $j]] 0] [string trimleft $nomb .]] != 1} {
		incr erreursplacement
		set answer [tk_messageBox -message "[mc {Erreur au nombre}] [expr $j + 1]" -type ok] 
		return
		}
	} else {
###################################################################################
		if {[string first , $nomb] == -1} {
#si l'opration est dcimale, si le nombre n'a pas de virgule, on force la virgule au bon endroit.
		set nomb [string replace $nomb [expr $partint] [expr $partint] ,]
		}
############################################################################""
	set nomb [string map {. 0} $nomb]
	set virg ,
	set tmp [lindex $donnee [expr $j]]
	if {[string first , $tmp] == -1} {set tmp $tmp$virg}
	set entier [expr [string first , $tmp]]
	if {$entier < $partint} { set tmp [string repeat 0 [expr $partint - $entier]]$tmp}
	set decimal [expr [string length $tmp] - [string first , $tmp] -1]
	if {$decimal < $partdec} { set tmp $tmp[string repeat 0 [expr $partdec - $decimal]]}
		if {[string equal $nomb $tmp] != 1} {
		incr erreursplacement
		set answer [tk_messageBox -message "[mc {Erreur au nombre}] [expr $j + 1]" -type ok] 
		return
		} 
	}
##########################################################################"
}

.bframe.consigne configure -text [mc {Effectue chaque colonne et valide en appuyant sur entree (Pour marquer les retenues, clique dans les cases)}]
for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    $c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
  }
}
set curcol $nbcol
set activecol $nbcol
set currow $nbrow
$c itemconf rectcol[expr \$curcol]row[expr \$currow] -fill white
for {set i 1} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow -1]} {incr j 1} {
    $c bind rectcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
    $c bind textcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
  }
}

#.bframe.ok configure -command "verifope $c"
catch {destroy .bframe.ok}
bind $c <Return> "verifope $c"

set pas 0
if {$decim == 1 && $activecol == [expr $partint + 2]} {
set pas 1
}
$c bind rectcol[expr \$activecol]row0 <ButtonRelease-1> "changeret $c"
$c bind textcol[expr \$activecol]row0 <ButtonRelease-1> "changeret $c"
$c bind rectcol[expr \$activecol- \$pas -1]row1 <ButtonRelease-1> "changeret $c"
$c bind textcol[expr \$activecol- \$pas -1]row1 <ButtonRelease-1> "changeret $c"


bind $c <Right> ""
bind $c <Up> ""
bind $c <Left> ""
bind $c <Down> ""
$c bind rectcol[expr \$curcol]row[expr \$currow] <ButtonRelease-1> "changefocus $c"
$c bind textcol[expr \$curcol]row[expr \$currow] <ButtonRelease-1> "changefocus $c"

for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
    $c itemconf  textcol[expr \$i]row[expr $nbrow] -text .
}

}

proc verifope {c} {
global curcol currow nbcol nbrow activecol indfich resultat total partint decim listdata erreurscalcul erreursplacement user
set result 0
set averif 0
# cas du nombre entier, ou du nombre dcimal quand on n'est pas sur la virgule
if {$decim ==0 || ($activecol != [expr $partint + 1])} {
#determination des chifres  traiter (ope1 et ope2)
set tmp [string map {. 0} [$c itemcget retcol[expr \$activecol]row0 -text]][string map {. 0} [$c itemcget textcol[expr \$activecol]row0 -text]]
if {$tmp == ""} {set tmp 0}
set ope1 [expr $tmp]
set retenue2 [$c itemcget retcol[expr \$activecol]row1 -text]
if {$retenue2 == "" || $retenue2 == "."} {set retenue2 0}
set tmp [string map {. 0 - 0} [$c itemcget textcol[expr \$activecol]row1 -text]]
if {$tmp == ""} {set tmp 0}
set ope2 [expr $tmp + $retenue2]
	set pas 0
# si activecol est juste avant la virgule, pas = 1, pour reperer la retenue "basse"  vrifier
		if {$decim == 1 && $activecol == [expr $partint + 2]} {
		set pas 1
		}
		if {([$c itemcget retcol[expr \$activecol - \$pas -1]row1 -text] !=1 && [$c itemcget retcol[expr \$activecol]row0 -text] ==1) || ([$c itemcget retcol[expr \$activecol - \$pas -1]row1 -text] ==1 && [$c itemcget retcol[expr \$activecol]row0 -text] !=1)} {
		incr erreurscalcul
		set answer [tk_messageBox -message [mc {Erreur dans les retenues}] -type ok] 
		return
		}

set result [expr $ope1 - $ope2]

set averif [string map {. 0} [$c itemcget textcol[expr \$activecol]row2 -text]]
}


	if {$decim == 1} {
		set pas 1
		if {$activecol == [expr $partint + 2]} {
		set pas 2
		}
	#set averif [string map {. 0} [$c itemcget textcol[expr \$activecol - $pas]row2 -text]]
#si on l'on doit traiter la virgule
		if {$activecol == [expr $partint +1]} {
		set averif ,
		set result [$c itemcget textcol[expr \$activecol]row2 -text]
			if {$averif != $result} {
			incr erreurscalcul
			set answer [tk_messageBox -message [mc {Erreur de calcul}] -type ok]
			return
			} else {
#substitution des valeurs par 0, pour rendre ok le test suivant de controle gnral
			set result 0
			set averif 0
			}
		}
	}


set averif [string trimleft $averif 0]
if {$averif == ""} {set averif 0}
set result [string trimleft $result 0]
if {$result == ""} {set result 0}

	if {[expr $averif] != [expr $result]} {
	incr erreurscalcul
	set answer [tk_messageBox -message [mc {Erreur de calcul}] -type ok] 
	return
	} else {
	set activecol [expr $activecol -1]
	for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  	for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    	$c itemconf  rectcol[expr \$i]row[expr \$j] -fill grey
	$c bind rectcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
	$c bind textcol[expr \$i]row[expr \$j] <ButtonRelease-1> ""
  	}
	}
		if {$activecol < 0} {
		$c itemconf operation -text "[$c itemcget operation -text] = $resultat"
		bind $c <Return> ""

		set str "\173[mc {Operation effectuee : }] [$c itemcget operation -text]\175"
		enregistreeval [mc {Soustractions}] [lindex $listdata 0] $str $user
		appendeval "\173[mc {Erreur(s) de placement :}]$erreursplacement\175\040\173[mc {Erreur(s) de calcul :}]$erreurscalcul\175" $user

		set answer [tk_messageBox -message "[mc {Operation terminee}] \n [mc {Erreur(s) de placement :}]$erreursplacement \n [mc {Erreur(s) de calcul :}]$erreurscalcul" -type ok]
		incr indfich
			if {$indfich < $total} {
			.bframe.consigne configure -text [mc {Appuie sur le bouton pour continuer}]
			button .bframe.ok -background #ffff80 -image ok1 -command "place $c"
			grid .bframe.ok -column 1 -padx 10 -row 0

			#.bframe.ok configure -command "place $c"
			return
			} else {
			.bframe.consigne configure -text [mc {C'est fini!}]
			#.bframe.ok configure -state disabled
			}
		} else {
		$c itemconf rectcol[expr \$activecol]row[expr \$nbrow] -fill white
		#$c bind retcol[expr \$activecol]row0 <ButtonRelease-1> "changeret $c"
		#$c bind retcol[expr \$activecol -1]row1 <ButtonRelease-1> "changeret $c"

set pas 0
if {$decim == 1 && $activecol == [expr $partint + 2]} {
set pas 1
}
#if {$decim == 1 && $activecol != [expr $partint + 1]} {

$c bind rectcol[expr \$activecol]row0 <ButtonRelease-1> "changeret $c"
$c bind textcol[expr \$activecol]row0 <ButtonRelease-1> "changeret $c"
$c bind rectcol[expr \$activecol- \$pas -1]row1 <ButtonRelease-1> "changeret $c"
$c bind textcol[expr \$activecol- \$pas -1]row1 <ButtonRelease-1> "changeret $c"
#}


		set currow $nbrow
		set curcol $activecol
		}
	}

}









